(* nderungen: in getcpuspeed:
    am Ende: t/10 statt vorher t/100 *)
(* noch ndern: Delay-Abfrage (irgendwann...) *)

unit wurmtool;
interface

uses dos,crt,graph,vgapro;

const levelnamen:array[1..100] of string[8]=
      ('aufgehts','weiterso','justdoit','holesdir','thunder5',
      'strikeit','reverse6','snakeway','rotated8','inverse5',
      '4corners','rastered','redheart','movedown','kreuzass',
      'gamename','thewatch','twoheart','tooheavy','bluenote',
      'goldcave','arrowsup','nicesoup','sixblock','thesword',
      'blackpik','ststlogo','tubecave','directiv','oktagons',
      'minimize','rechteck','ellipses','twokaros','openkaro',
      'thecross','rightway','thelight','theatres','manyslit',
      'perfored','undowall','rastedge','opencase','flatwall',
      'trilines','widerast','fourbows','aproblem','morewall',
      'goodluck','moreline','theedges','nicework','upstairs',
      'incenter','bighouse','nospaces','hardcore','leftside',
      'passages','wormscan','attentio','damnline','twolines',
      'edgeline','adivided','newlevel','lousymap','endofmap',
      'twosnail','bigsnare','anywhere','bigcross','craterup',
      'labyrint','britflag','calmdown','highways','blockway',
      'mastered','morefear','football','fiverows','phonenow',
      'noendway','uptodown','leaveway','nowayout','uglycave',
      'netmoves','constant','smallbox','gonoways','nowtryit',
      'goharder','breakout','hardwork','veryfine','goodwork');
      



type feldtyp=array[0..127,0..87] of byte; {x:0 bis 639 ; y: 20 bis 459 ;
                                          oben :Spieler 1;unten Spieler 2
                                          1 Kstchen : 5*5 pixel}
     highscoretyp=record
                 punkte:array[1..21] of record
                                          name:string[20];
                                          level:integer;
                                          punkte:longint;
                                        end;
                 lang:array[1..100,1..11] of record
                                               name:string[20];
                                               lang:word;
                                             end;
              end;

var feld:feldtyp;
    bildfile:file;
    bildspeicher:pointer;
    datei:file of feldtyp;
    highscore:file of highscoretyp;
    highdaten:highscoretyp;
    waittime:integer;
    lang:array[1..2] of integer;
    pos1,pos2:record x,y:word;end;
    steine:array[1..10] of pointer;
    lauf,steinwert:integer;
    wurm:array[1..2,1..3000]of record
                            x,y,dir:byte;
                          end;
    endpos,lastlevel:array[1..2] of integer;
    cpuspeed:integer;
    direction,altdirection:array[1..2] of byte;
    punkte:array[1..2] of longint;
    wurmkopf:array[1..2] of record
                           n,o,s,w:pointer;
                         end;
    wurmleib:array[1..2] of record
                           h,v,lu,lo,ro,ru:pointer;   {horiz,vert,links unten,...}
                         end;
    wurmende:array[1..2] of record
                           n,o,s,w:pointer;
                         end;
    spieleranzahl,altlevel,level,Schwierigkeit:longint;
    name:array[1..2] of string;
    leben:array[1..2] of integer;
    spieler,aktiv:array[1..2] of boolean;
    c1,c2:char;


procedure shownewlevel(level:byte);
procedure deletelanghigh;
procedure deletepunktehigh;
procedure showpunktehigh;
procedure showlanghigh;
procedure wurmloeschen(worm:integer);
procedure setzeneuenstein;
procedure showgamedata;
procedure showfeld;
procedure steinedef;
procedure wurmdef;
procedure neuesspiel;
procedure drawdoublemenu(x1,y1,x2,y2,d:word;normal,hell,dunkel:byte);
procedure readnumber(x,y:word;backgcol:byte;len:byte;var num:longint);
procedure readstring(x,y:word;backgcol:byte;len:byte;var readvar:string);
procedure drawinactivemenufield(x1,y1,x2,y2,ys,thick:word;text:string);
procedure drawactivemenufield(x1,y1,x2,y2,ys,thick:word;text:string);
procedure startmenu;
procedure movewurm;
procedure passwort;
procedure neueshighscore;
procedure checklanghigh;
procedure checkpunktehigh;
procedure getcpuspeed;

implementation

procedure getcpuspeed;
var x,y,b:byte;
    h,m,s,c,h2,m2,s2,c2,dh,dm,ds,dc,t,i,r:word;
begin
for x:=0 to 127 do begin
for y:=0 to 87 do begin
if (x mod 127 =0) or (y mod 87=0) then feld[x,y]:=1 else feld[x,y]:=0;
end;end;
showfeld;
lang[1]:=4;
gettime(h,m,s,c);
for y:=1 to 10 do begin
 wurm[1,1].x:=10;
 wurm[1,1].y:=y;
 direction[1]:=2;
 altdirection[1]:=2;
 wurm[1,2].x:=9;
 wurm[1,2].y:=y;
 wurm[1,3].x:=9;
 wurm[1,3].y:=y;
 wurm[1,4].x:=9;
 wurm[1,4].y:=y;
 aktiv[1]:=true;
 waittime:=0;
for b:=1 to 100 do begin
movewurm;
end;
end;
gettime(h2,m2,s2,c2);
dc:=c2-c;ds:=s2-s;dm:=m2-m;dh:=h2-h;
if c2<c then begin dc:=dc+100;ds:=ds-1; end;
if ds<0 then begin ds:=ds+60;dm:=dm-1;end;
if dm<0 then begin dm:=dm+60;dh:=dh-1;end;
t:=dc+100*ds+60*100*dm+3600*100*dh;
cpuspeed:=t div 10;

end;

procedure wurmloeschen(worm:integer);
begin
setfillstyle(1,0);
for lauf:=2 to lang[worm] do begin
 feld[wurm[worm,lauf].x,wurm[worm,lauf].y]:=0;
 bar(wurm[worm,lauf].x*5,wurm[worm,lauf].y*5+40,wurm[worm,lauf].x*5+4,wurm[worm,lauf].y*5+44);
end;
end;

procedure movewurm;
begin
delay(waittime);
setfillstyle(1,0);
if aktiv[1] then begin
bar(wurm[1,lang[1]].x*5,wurm[1,lang[1]].y*5+40,wurm[1,lang[1]].x*5+4,wurm[1,lang[1]].y*5+44);
feld[wurm[1,lang[1]].x,wurm[1,lang[1]].y]:=0;
for lauf:=lang[1]-1 downto 1 do begin
  wurm[1,lauf+1]:=wurm[1,lauf];
end;
case direction[1] of
1:begin
dec(wurm[1,1].y);
end;
2:begin
inc(wurm[1,1].x);
end;
3:begin
inc(wurm[1,1].y);
end;
4:begin
dec(wurm[1,1].x);
end;
end;
if (feld[wurm[1,1].x,wurm[1,1].y]>0) and (feld[wurm[1,1].x,wurm[1,1].y]<240) then begin aktiv[1]:=false;wurmloeschen(1);end;
if feld[wurm[1,1].x,wurm[1,1].y]>249 then begin
                                            sound(300);
                                            inc(punkte[1],steinwert);
                                            inc(lang[1],steinwert);
                                            inc(steinwert);
                                            setzeneuenstein;
                                            nosound;
                                          end;
if feld[wurm[1,1].x,wurm[1,1].y]=255 then begin inc(leben[1]);showgamedata;end;

feld[wurm[1,1].x,wurm[1,1].y]:=10 + direction[1];
if aktiv[1] then case direction[1] of
1:putimage(wurm[1,1].x*5,wurm[1,1].y*5+40,wurmkopf[1].n^,0);
2:putimage(wurm[1,1].x*5,wurm[1,1].y*5+40,wurmkopf[1].o^,0);
3:putimage(wurm[1,1].x*5,wurm[1,1].y*5+40,wurmkopf[1].s^,0);
4:putimage(wurm[1,1].x*5,wurm[1,1].y*5+40,wurmkopf[1].w^,0);
end;
setfillstyle(1,0);
if aktiv[1] then case altdirection[1] of
1:begin
    if direction[1]=1 then putimage(wurm[1,2].x*5,wurm[1,2].y*5+40,wurmleib[1].v^,0);
    if direction[1]=2 then putimage(wurm[1,2].x*5,wurm[1,2].y*5+40,wurmleib[1].ru^,0);
    if direction[1]=4 then putimage(wurm[1,2].x*5,wurm[1,2].y*5+40,wurmleib[1].lu^,0);
  end;
2:begin
    if direction[1]=2 then putimage(wurm[1,2].x*5,wurm[1,2].y*5+40,wurmleib[1].h^,0);
    if direction[1]=3 then putimage(wurm[1,2].x*5,wurm[1,2].y*5+40,wurmleib[1].lu^,0);
    if direction[1]=1 then putimage(wurm[1,2].x*5,wurm[1,2].y*5+40,wurmleib[1].lo^,0);
  end;
3:begin
    if direction[1]=3 then putimage(wurm[1,2].x*5,wurm[1,2].y*5+40,wurmleib[1].v^,0);
    if direction[1]=2 then putimage(wurm[1,2].x*5,wurm[1,2].y*5+40,wurmleib[1].ro^,0);
    if direction[1]=4 then putimage(wurm[1,2].x*5,wurm[1,2].y*5+40,wurmleib[1].lo^,0);
  end;
4:begin                                                      
    if direction[1]=1 then putimage(wurm[1,2].x*5,wurm[1,2].y*5+40,wurmleib[1].ro^,0);
    if direction[1]=3 then putimage(wurm[1,2].x*5,wurm[1,2].y*5+40,wurmleib[1].ru^,0);
    if direction[1]=4 then putimage(wurm[1,2].x*5,wurm[1,2].y*5+40,wurmleib[1].h^,0);
  end;
end;
if aktiv[1] then case wurm[1,lang[1]].dir of
 1:putimage(wurm[1,lang[1]].x*5,wurm[1,lang[1]].y*5+40,wurmende[1].n^,0);
 2:putimage(wurm[1,lang[1]].x*5,wurm[1,lang[1]].y*5+40,wurmende[1].o^,0);
 3:putimage(wurm[1,lang[1]].x*5,wurm[1,lang[1]].y*5+40,wurmende[1].s^,0);
 4:putimage(wurm[1,lang[1]].x*5,wurm[1,lang[1]].y*5+40,wurmende[1].w^,0);
end;
end;
if aktiv[2] then begin
bar(wurm[2,lang[2]].x*5,wurm[2,lang[2]].y*5+40,wurm[2,lang[2]].x*5+4,wurm[2,lang[2]].y*5+44);
feld[wurm[2,lang[2]].x,wurm[2,lang[2]].y]:=0;
for lauf:=lang[2]-1 downto 1 do begin
  wurm[2,lauf+1]:=wurm[2,lauf];
end;

case direction[2] of
1:begin
dec(wurm[2,1].y);
end;
2:begin
inc(wurm[2,1].x);
end;
3:begin
inc(wurm[2,1].y);
end;
4:begin
dec(wurm[2,1].x);
end;
end;
if (feld[wurm[2,1].x,wurm[2,1].y]>0) and (feld[wurm[2,1].x,wurm[2,1].y]<240) then begin aktiv[2]:=false;wurmloeschen(2);end;
if feld[wurm[2,1].x,wurm[2,1].y]>249 then begin
                                            sound(300);
                                            inc(punkte[2],steinwert);
                                            inc(lang[2],steinwert);
                                            inc(steinwert);
                                            setzeneuenstein;
                                            nosound;
                                          end;
if feld[wurm[2,1].x,wurm[2,1].y]=255 then begin inc(leben[2]);showgamedata;end;

feld[wurm[2,1].x,wurm[2,1].y]:=14 + direction[1];
if aktiv[2] then case direction[2] of
1:putimage(wurm[2,1].x*5,wurm[2,1].y*5+40,wurmkopf[2].n^,0);
2:putimage(wurm[2,1].x*5,wurm[2,1].y*5+40,wurmkopf[2].o^,0);
3:putimage(wurm[2,1].x*5,wurm[2,1].y*5+40,wurmkopf[2].s^,0);
4:putimage(wurm[2,1].x*5,wurm[2,1].y*5+40,wurmkopf[2].w^,0);
end;
if aktiv[2] then case altdirection[2] of
1:begin
    if direction[2]=1 then putimage(wurm[2,2].x*5,wurm[2,2].y*5+40,wurmleib[2].v^,0);
    if direction[2]=2 then putimage(wurm[2,2].x*5,wurm[2,2].y*5+40,wurmleib[2].ru^,0);
    if direction[2]=4 then putimage(wurm[2,2].x*5,wurm[2,2].y*5+40,wurmleib[2].lu^,0);
  end;
2:begin
    if direction[2]=2 then putimage(wurm[2,2].x*5,wurm[2,2].y*5+40,wurmleib[2].h^,0);
    if direction[2]=3 then putimage(wurm[2,2].x*5,wurm[2,2].y*5+40,wurmleib[2].lu^,0);
    if direction[2]=1 then putimage(wurm[2,2].x*5,wurm[2,2].y*5+40,wurmleib[2].lo^,0);
  end;
3:begin
    if direction[2]=3 then putimage(wurm[2,2].x*5,wurm[2,2].y*5+40,wurmleib[2].v^,0);
    if direction[2]=2 then putimage(wurm[2,2].x*5,wurm[2,2].y*5+40,wurmleib[2].ro^,0);
    if direction[2]=4 then putimage(wurm[2,2].x*5,wurm[2,2].y*5+40,wurmleib[2].lo^,0);
  end;
4:begin
    if direction[2]=1 then putimage(wurm[2,2].x*5,wurm[2,2].y*5+40,wurmleib[2].ro^,0);
    if direction[2]=3 then putimage(wurm[2,2].x*5,wurm[2,2].y*5+40,wurmleib[2].ru^,0);
    if direction[2]=4 then putimage(wurm[2,2].x*5,wurm[2,2].y*5+40,wurmleib[2].h^,0);
  end;
end;
if aktiv[2] then case wurm[2,lang[2]].dir of
 1:putimage(wurm[2,lang[2]].x*5,wurm[2,lang[2]].y*5+40,wurmende[2].n^,0);
 2:putimage(wurm[2,lang[2]].x*5,wurm[2,lang[2]].y*5+40,wurmende[2].o^,0);
 3:putimage(wurm[2,lang[2]].x*5,wurm[2,lang[2]].y*5+40,wurmende[2].s^,0);
 4:putimage(wurm[2,lang[2]].x*5,wurm[2,lang[2]].y*5+40,wurmende[2].w^,0);
end;
end;
altdirection:=direction;
end;

procedure setzeneuenstein;
var x,y:byte;
begin
randomize;
repeat
x:=random(126)+1;
y:=random(86)+1;
until feld[x,y]=0;
if random(20)>0 then feld[x,y]:=250 else feld[x,y]:=255;
if feld[x,y]=250 then putimage(x*5,y*5+40,steine[6]^,0);
if feld[x,y]=255 then putimage(x*5,y*5+40,steine[3]^,0);
showgamedata;
end;

procedure showfeld;
var x,y:byte;
begin
setfillstyle(1,0);
for x:=0 to 127 do begin
for y:=0 to 87 do begin
bar(x*5,y*5+40,x*5+4,y*5+44);
if (feld[x,y]>0) and (feld[x,y]<11) then putimage(x*5,y*5+40,steine[feld[x,y]]^,0);
if feld[x,y]>10 then begin
 case feld[x,y] of
   11:if aktiv[1] then putimage(x*5,y*5+40,wurmkopf[1].n^,0);
   12:if aktiv[1] then putimage(x*5,y*5+40,wurmkopf[1].o^,0);
   13:if aktiv[1] then putimage(x*5,y*5+40,wurmkopf[1].s^,0);
   14:if aktiv[1] then putimage(x*5,y*5+40,wurmkopf[1].w^,0);
   15:if aktiv[2] then putimage(x*5,y*5+40,wurmkopf[2].n^,0);
   16:if aktiv[2] then putimage(x*5,y*5+40,wurmkopf[2].o^,0);
   17:if aktiv[2] then putimage(x*5,y*5+40,wurmkopf[2].s^,0);
   18:if aktiv[2] then putimage(x*5,y*5+40,wurmkopf[2].w^,0);
 end;
end;
end;
end;
end;

procedure showgamedata;
var txt:string;
begin
drawdoublemenu(0,0,319,19,2,13,32,12);
drawdoublemenu(0,20,259,39,2,13,32,12);
drawdoublemenu(320,0,639,19,2,15,14,2);
drawdoublemenu(380,20,639,39,2,15,14,2);
drawdoublemenu(260,20,379,39,2,16,18,17);
setcolor(0);
str(level:3,txt);
outtextxy(285,27,'LEVEL '+txt);
str(leben[1]:3,txt);
outtextxy(5,7,name[1]+'  /  Rest-Leben : '+txt);
str(punkte[1]*schwierigkeit:5,txt);
outtextxy(5,27,'Punkte : '+txt);
str(lang[1]:4,txt);
outtextxy(125,27,'Wurmlnge : '+txt);
if spieleranzahl=2 then begin
 str(punkte[2]*schwierigkeit:5,txt);
 outtextxy(385,27,'Punkte : '+txt);
 str(leben[2]:3,txt);
 if spieleranzahl=2 then outtextxy(325,7,name[2]+'  /  Rest-Leben : '+txt);
 str(lang[2]:4,txt);
 outtextxy(505,27,'Wurmlnge : '+txt);
end;
end;

procedure neueshighscore;
var lauf2:integer;
begin
rewrite(highscore);
for lauf :=1 to 20 do begin
  highdaten.punkte[lauf].name:='--- kein Eintrag ---';
  highdaten.punkte[lauf].level:=0;
  highdaten.punkte[lauf].punkte:=0;
end;
for lauf:=1 to 100 do begin
  for lauf2:= 1 to 10 do begin
    highdaten.lang[lauf,lauf2].name:='--- kein Eintrag ---';
    highdaten.lang[lauf,lauf2].lang:=0;
  end;
end;
seek(highscore,0);
write(highscore,highdaten);
end;

procedure checkpunktehigh;
var schreiben:boolean;
begin
schreiben:=false;
if punkte[1]>=highdaten.punkte[20].punkte then schreiben:=true;
lauf:=20;
if schreiben then repeat
highdaten.punkte[lauf+1].punkte:=highdaten.punkte[lauf].punkte;
highdaten.punkte[lauf+1].name:=highdaten.punkte[lauf].name;
highdaten.punkte[lauf+1].level:=highdaten.punkte[lauf].level;
if punkte[1]>=highdaten.punkte[lauf].punkte then begin
highdaten.punkte[lauf].punkte:=punkte[1];
highdaten.punkte[lauf].name:=name[1];
highdaten.punkte[lauf].level:=lastlevel[1];
end;
dec(lauf);
if punkte[1]<highdaten.punkte[lauf].punkte then schreiben:=false;
until (schreiben=false) or (lauf=0);
if spieleranzahl=2 then begin
schreiben:=false;
if punkte[2]>=highdaten.punkte[20].punkte then schreiben:=true;
lauf:=20;
if schreiben then repeat
highdaten.punkte[lauf+1].punkte:=highdaten.punkte[lauf].punkte;
highdaten.punkte[lauf+1].name:=highdaten.punkte[lauf].name;
highdaten.punkte[lauf+1].level:=highdaten.punkte[lauf].level;
if punkte[2]>=highdaten.punkte[lauf].punkte then begin
highdaten.punkte[lauf].punkte:=punkte[2];
highdaten.punkte[lauf].name:=name[2];
highdaten.punkte[lauf].level:=lastlevel[2];
end;
dec(lauf);
if punkte[2]<highdaten.punkte[lauf].punkte then schreiben:=false;
until (schreiben=false) or (lauf=0);
end;
end;


procedure checklanghigh;
var schreiben:boolean;
begin

if spieler[1] then begin
schreiben:=false;
if lang[1]>=highdaten.lang[level,10].lang then schreiben:=true;
lauf:=10;
if schreiben then repeat
highdaten.lang[level,lauf+1].lang:=highdaten.lang[level,lauf].lang;
highdaten.lang[level,lauf+1].name:=highdaten.lang[level,lauf].name;
if lang[1]>=highdaten.lang[level,lauf+1].lang then begin
highdaten.lang[level,lauf].lang:=lang[1];
highdaten.lang[level,lauf].name:=name[1];
end;
dec(lauf);
if lang[1]<highdaten.lang[level,lauf].lang then schreiben:=false;
until (lauf=0) or not schreiben;
end;

if spieler[2] then begin
schreiben:=false;
if lang[2]>=highdaten.lang[level,10].lang then schreiben:=true;
lauf:=10;
if schreiben then repeat
highdaten.lang[level,lauf+1].lang:=highdaten.lang[level,lauf].lang;
highdaten.lang[level,lauf+1].name:=highdaten.lang[level,lauf].name;
if lang[2]>=highdaten.lang[level,lauf+1].lang then begin
highdaten.lang[level,lauf].lang:=lang[2];
highdaten.lang[level,lauf].name:=name[2];
end;
dec(lauf);
if lang[2]<highdaten.lang[level,lauf].lang then schreiben:=false;
until (lauf=0) or not schreiben
end;
end;

procedure shownewlevel(level:byte);
var txt:string;
begin
drawdoublemenu(55,150,584,364,5,8,5,11);
str(level:3,txt);
settextstyle(triplexfont,0,6);
setcolor(11);
outtextxy(190,155,'LEVEL '+txt);
outtextxy(185,225,'PASSWORT:');
outtextxy(200,295,levelnamen[level]);
setcolor(5);
outtextxy(188,153,'LEVEL '+txt);
outtextxy(183,223,'PASSWORT:');
outtextxy(198,293,levelnamen[level]);
setcolor(8);
outtextxy(189,154,'LEVEL '+txt);
outtextxy(184,224,'PASSWORT:');
outtextxy(199,294,levelnamen[level]);
while keypressed do c2:=readkey;
c2:=readkey;
settextstyle(0,0,1);
end;


procedure neuesspiel;
var c:char;
    x,y:byte;
begin
punkte[1]:=0;punkte[2]:=0;
assign(datei,'wurm256.dat');
reset(datei);
seek(highscore,0);
read(highscore,highdaten);
leben[1]:=3;leben[2]:=3;
if spieleranzahl=1 then leben[2]:=0;
repeat
steinwert:=2;
if leben[1]=0 then spieler[1]:=false else spieler[1]:=true;
if leben[2]=0 then spieler[2]:=false else spieler[2]:=true;
aktiv:=spieler;
if aktiv[1] then lastlevel[1]:=level;
if aktiv[2] then lastlevel[2]:=level;
lang[1]:=2;lang[2]:=2;
for lauf:=1 to 3000 do begin
 wurm[1,lauf].x:=200;
 wurm[1,lauf].y:=100;
 wurm[2,lauf].x:=200;
 wurm[2,lauf].y:=100;
end;

(* NEUES LEVEL LADEN *)
cleardevice;
showgamedata;
shownewlevel(level);
seek(datei,level-1);
read(datei,feld);
for x:=0 to 127 do begin
for y:=0 to 87 do begin
if feld[x,y]>10 then begin
 case feld[x,y] of
  11:begin
      wurm[1,1].x:=x;
      wurm[1,1].y:=y;
      direction[1]:=1;
      wurm[1,2].x:=x;
      wurm[1,2].y:=y+1;
     end;
  12:begin
      wurm[1,1].x:=x;
      wurm[1,1].y:=y;
      direction[1]:=2;
      wurm[1,2].x:=x-1;
      wurm[1,2].y:=y;
     end;
  13:begin
      wurm[1,1].x:=x;
      wurm[1,1].y:=y;
      direction[1]:=3;
      wurm[1,2].x:=x;
      wurm[1,2].y:=y-1;
     end;
  14:begin
      wurm[1,1].x:=x;
      wurm[1,1].y:=y;
      direction[1]:=4;
      wurm[1,2].x:=x+1;
      wurm[1,2].y:=y;
     end;
  15:begin
      wurm[2,1].x:=x;
      wurm[2,1].y:=y;
      direction[2]:=1;
      wurm[2,2].x:=x;
      wurm[2,2].y:=y+1;
     end;
  16:begin
      wurm[2,1].x:=x;
      wurm[2,1].y:=y;
      direction[2]:=2;
      wurm[2,2].x:=x-1;
      wurm[2,2].y:=y;
     end;
  17:begin
      wurm[2,1].x:=x;
      wurm[2,1].y:=y;
      direction[2]:=3;
      wurm[2,2].x:=x;
      wurm[2,2].y:=y-1;
     end;
  18:begin
      wurm[2,1].x:=x;
      wurm[2,1].y:=y;
      direction[2]:=4;
      wurm[2,2].x:=x+1;
      wurm[2,2].y:=y;
     end;
 end;
 if not aktiv[1] then feld[wurm[1,1].x,wurm[1,1].y]:=0;
 if not aktiv[2] then feld[wurm[2,1].x,wurm[2,1].y]:=0;
 wurm[1,1].dir:=direction[1];
 wurm[2,1].dir:=direction[2];
end;
end;
end;
showfeld;
showgamedata;
setzeneuenstein;
delay(1000);
while keypressed do c2:=readkey;
c2:=readkey;
repeat
if keypressed then begin
   c:=readkey;
   case c of
   'p','P': begin
   repeat  
   until keypressed;
   c1:=readkey;
   if c1=#27 then begin
   c1:=readkey;
   if c1=#27 then begin
   leben[1]:=0;leben[2]:=0;aktiv[1]:=false;aktiv[2]:=false;spieler[1]:=false;
   spieler[2]:=false;
   end;
   end;
   end;
   'a','A':if aktiv[2] and (altdirection[2]<>2) then direction[2]:=4;
   's','S':if aktiv[2] and (altdirection[2]<>1) then direction[2]:=3;
   'd','D':if aktiv[2] and (altdirection[2]<>4) then direction[2]:=2;
   'w','W':if aktiv[2] and (altdirection[2]<>3) then direction[2]:=1;
   #0 :if aktiv[1] then case readkey of
             #72:if (altdirection[1]<>3) then direction[1]:=1;
             #80:if (altdirection[1]<>1) then direction[1]:=3;
             #77:if (altdirection[1]<>4) then direction[1]:=2;
             #75:if (altdirection[1]<>2) then direction[1]:=4;
        end;                                      
   end;
end;
wurm[1,1].dir:=direction[1];
wurm[2,1].dir:=direction[2];
altdirection[1]:=wurm[1,2].dir;
altdirection[2]:=wurm[2,2].dir;
movewurm;
until not aktiv[1] and not aktiv[2];
sound(70);delay(100);
sound(55);delay(100);
sound(45);delay(100);
sound(40);delay(100);
sound(35);delay(100);
sound(30);delay(100);
sound(25);delay(100);
nosound;
if schwierigkeit>0 then checklanghigh;
if (lang[1]>=100) or (lang[2]>=100) then inc(level);
if (lang[1]>=100) then inc(leben[1]);
if lang[2]>=100 then inc(leben[2]);
dec(leben[1]);dec(leben[2]);
if leben[1]<0 then leben[1]:=0;
if leben[2]<0 then leben[2]:=0;
until (level=101) or (not spieler[1] and not spieler[2]);
punkte[1]:=punkte[1]*schwierigkeit;
punkte[2]:=punkte[2]*schwierigkeit;
checkpunktehigh;
seek(highscore,0);
write(highscore,highdaten);
close(datei);
end;

procedure passwort;
var passby:string;
    txt:string;
begin
drawactivemenufield(5,30,319,54,38,2,'Passwort =>       ');
readstring(180,38,19,8,passby);
delay(150);
for lauf:=1 to 100 do begin
  if levelnamen[lauf]=passby then level:=lauf;
end;



str(level,txt);
drawinactivemenufield(320,5,634,29,13,2,'Level '+txt);
end;

procedure drawinactivemenufield(x1,y1,x2,y2,ys,thick:word;text:string);
var xs:integer;
begin
settextstyle(0,0,1);
drawdoublemenu(x1,y1,x2,y2,thick,16,18,17);
xs:=x1+(((x2-x1)+thick*2+2)-(textwidth(text))) div 2;
setcolor(0);
outtextxy(xs,ys,text);
end;

procedure drawactivemenufield(x1,y1,x2,y2,ys,thick:word;text:string);
var xs:integer;
begin
settextstyle(0,0,1);
drawdoublemenu(x1,y1,x2,y2,thick,19,21,20);
xs:=x1+(((x2-x1)+thick*2+2)-(textwidth(text))) div 2;
setcolor(0);
outtextxy(xs,ys,text);
end;

procedure deletepunktehigh;
begin
 seek(highscore,0);
 read(highscore,highdaten);
 for lauf :=1 to 20 do begin
  highdaten.punkte[lauf].name:='--- kein Eintrag ---';
  highdaten.punkte[lauf].level:=0;
  highdaten.punkte[lauf].punkte:=0;
 end;
seek(highscore,0);
write(highscore,highdaten);
end;

procedure deletelanghigh;
var lauf2:integer;
begin
 seek(highscore,0);
 read(highscore,highdaten);
 for lauf:=1 to 100 do begin
  for lauf2:= 1 to 10 do begin
    highdaten.lang[lauf,lauf2].name:='--- kein Eintrag ---';
    highdaten.lang[lauf,lauf2].lang:=0;
  end;
end;
seek(highscore,0);
write(highscore,highdaten);
end;



procedure showpunktehigh;
var waehle,auswahl:byte;
    c1:char;
    txt1,txt2,txt3:string;
begin
drawdoublemenu(0,0,639,479,3,15,14,2);
drawinactivemenufield(5,5,319,29,13,2,'Zurck');
drawinactivemenufield(320,5,634,29,13,2,'Highscores lschen');
(* HIER ANZEIGE HIGHSCORE EINBINDEN *)
drawdoublemenu(195,32,444,61,3,8,5,10);
settextstyle(7,0,3);
setcolor(5);
outtextxy(226,30,'HIGHSCORES');
setcolor(10);
outtextxy(228,32,'HIGHSCORES');
setcolor(8);
outtextxy(227,31,'HIGHSCORES');
settextstyle(0,0,1);
 seek(highscore,0);
 read(highscore,highdaten);
drawdoublemenu(5,66,634,85,2,8,5,10);
drawdoublemenu(5,86,634,105,2,8,5,10);
drawdoublemenu(5,106,634,125,2,8,5,10);
drawdoublemenu(5,126,634,145,2,16,18,17);
drawdoublemenu(5,146,634,165,2,16,18,17);
drawdoublemenu(5,166,634,185,2,16,18,17);
drawdoublemenu(5,186,634,205,2,24,8,25);
drawdoublemenu(5,206,634,225,2,24,8,25);
drawdoublemenu(5,226,634,245,2,24,8,25);
drawdoublemenu(5,246,634,265,2,30,22,31);
drawdoublemenu(5,266,634,285,2,30,22,31);
drawdoublemenu(5,286,634,305,2,30,22,31);
drawdoublemenu(5,306,634,325,2,30,22,31);
drawdoublemenu(5,326,634,345,2,30,22,31);
drawdoublemenu(5,346,634,365,2,30,22,31);
drawdoublemenu(5,366,634,385,2,30,22,31);
drawdoublemenu(5,386,634,405,2,30,22,31);
drawdoublemenu(5,406,634,425,2,30,22,31);
drawdoublemenu(5,426,634,445,2,30,22,31);
drawdoublemenu(5,446,634,465,2,30,22,31);
setcolor(0);
for lauf:=1 to 20 do begin
str(lauf:2,txt3);
str(highdaten.punkte[lauf].punkte:5,txt1);
str(highdaten.punkte[lauf].level:3,txt2);
outtextxy(15,52+20*lauf,'  '+txt3+'. : Name : '+highdaten.punkte[lauf].name);
outtextxy(330,52+20*lauf,' Punktzahl : '+txt1+'    Level : '+txt2);
end;
auswahl:=2;
waehle:=0;
repeat
case waehle of
0:drawactivemenufield(5,5,319,29,13,2,'Zurck');
1:drawactivemenufield(320,5,634,29,13,2,'Highscores lschen');
end;
c1:=readkey;
drawinactivemenufield(5,5,319,29,13,2,'Zurck');
drawinactivemenufield(320,5,634,29,13,2,'Highscores lschen');
case c1 of
#77:waehle:=1;
#75:waehle:=0;
#13:auswahl:=waehle;
end;
if auswahl=1 then begin
 drawinactivemenufield(320,5,634,29,13,2,'Wirklich lschen ? <ESC> fr JA');
 c1:=readkey;
 if c1=#27 then deletepunktehigh;
drawdoublemenu(195,32,444,61,3,8,5,10);
settextstyle(7,0,3);
setcolor(5);
outtextxy(226,30,'HIGHSCORES');
setcolor(10);
outtextxy(228,32,'HIGHSCORES');
setcolor(8);
outtextxy(227,31,'HIGHSCORES');
settextstyle(0,0,1);
 seek(highscore,0);
 read(highscore,highdaten);
drawdoublemenu(5,66,634,85,2,8,5,10);
drawdoublemenu(5,86,634,105,2,8,5,10);
drawdoublemenu(5,106,634,125,2,8,5,10);
drawdoublemenu(5,126,634,145,2,16,18,17);
drawdoublemenu(5,146,634,165,2,16,18,17);
drawdoublemenu(5,166,634,185,2,16,18,17);
drawdoublemenu(5,186,634,205,2,24,8,25);
drawdoublemenu(5,206,634,225,2,24,8,25);
drawdoublemenu(5,226,634,245,2,24,8,25);
drawdoublemenu(5,246,634,265,2,30,22,31);
drawdoublemenu(5,266,634,285,2,30,22,31);
drawdoublemenu(5,286,634,305,2,30,22,31);
drawdoublemenu(5,306,634,325,2,30,22,31);
drawdoublemenu(5,326,634,345,2,30,22,31);
drawdoublemenu(5,346,634,365,2,30,22,31);
drawdoublemenu(5,366,634,385,2,30,22,31);
drawdoublemenu(5,386,634,405,2,30,22,31);
drawdoublemenu(5,406,634,425,2,30,22,31);
drawdoublemenu(5,426,634,445,2,30,22,31);
drawdoublemenu(5,446,634,465,2,30,22,31);
setcolor(0);
for lauf:=1 to 20 do begin
str(lauf:2,txt3);
str(highdaten.punkte[lauf].punkte:5,txt1);
str(highdaten.punkte[lauf].level:3,txt2);
outtextxy(15,52+20*lauf,'  '+txt3+'. : Name : '+highdaten.punkte[lauf].name);
outtextxy(330,52+20*lauf,' Punktzahl : '+txt1+'    Level : '+txt2);
end;
 auswahl:=2;
end;
until auswahl=0;
end;

procedure showlanghigh;
var waehle,auswahl:integer;
    nummer:longint;
    txt1,txt2,txt3:string;
    c1:char;
begin
drawdoublemenu(0,0,639,479,3,15,14,2);
auswahl:=3;
waehle:=0;
nummer:=1;
 (* LNGEN - HIGHSCORES HIER !!! *)
  drawdoublemenu(195,32,444,61,3,8,5,10);
  drawdoublemenu(195,62,444,95,3,8,5,10);
  settextstyle(7,0,3);
  setcolor(5);
  str(nummer:4,txt1);
  outtextxy(226,30,'HIGHSCORES');
  outtextxy(236,63,'LEVEL '+txt1);
  setcolor(10);
  outtextxy(228,32,'HIGHSCORES');
  outtextxy(238,65,'LEVEL '+txt1);
  setcolor(8);
  outtextxy(227,31,'HIGHSCORES');
  outtextxy(237,64,'LEVEL '+txt1);
  settextstyle(0,0,1);
   seek(highscore,0);
   read(highscore,highdaten);
  drawdoublemenu(5,96,634,115,2,8,5,10);
  drawdoublemenu(5,116,634,135,2,8,5,10);
  drawdoublemenu(5,136,634,155,2,8,5,10);
  drawdoublemenu(5,156,634,175,2,16,18,17);
  drawdoublemenu(5,176,634,195,2,16,18,17);
  drawdoublemenu(5,196,634,215,2,16,18,17);
  drawdoublemenu(5,216,634,235,2,24,8,25);
  drawdoublemenu(5,236,634,255,2,24,8,25);
  drawdoublemenu(5,256,634,275,2,24,8,25);
  drawdoublemenu(5,276,634,295,2,24,8,25);
  setcolor(0);
  for lauf:=1 to 10 do begin
  str(lauf:2,txt3);
  str(highdaten.lang[nummer,lauf].lang:4,txt1);
  outtextxy(15,82+20*lauf,'  '+txt3+'. : Name : '+highdaten.lang[nummer,lauf].name);
  outtextxy(330,82+20*lauf,' Wurmlnge : '+txt1);
  end;
drawinactivemenufield(5,5,214,29,13,2,'Zurck');
drawinactivemenufield(215,5,424,29,13,2,'Highscores lschen');
drawinactivemenufield(425,5,634,29,13,2,'Level whlen');
repeat
case waehle of
0:drawactivemenufield(5,5,214,29,13,2,'Zurck');
1:drawactivemenufield(215,5,424,29,13,2,'Highscores lschen');
2:drawactivemenufield(425,5,634,29,13,2,'Level whlen');
end;
c1:=readkey;
drawinactivemenufield(5,5,214,29,13,2,'Zurck');
drawinactivemenufield(215,5,424,29,13,2,'Highscores lschen');
drawinactivemenufield(425,5,634,29,13,2,'Level whlen');
case c1 of
#77:inc(waehle);
#75:dec(waehle);
#13:auswahl:=waehle;
#72:if waehle=2 then begin inc(nummer);auswahl:=4;end;
#80:if waehle=2 then begin dec(nummer);auswahl:=4;end;
end;
if waehle<0 then waehle:=2;
if waehle>2 then waehle:=0;
if auswahl=4 then begin
 if nummer<1 then nummer:=1;
 if nummer>100 then nummer:=100;
 (* LNGEN - HIGHSCORES HIER !!! *)
  drawdoublemenu(195,32,444,61,3,8,5,10);
  drawdoublemenu(195,62,444,95,3,8,5,10);
  settextstyle(7,0,3);
  setcolor(5);
  str(nummer:4,txt1);
  outtextxy(226,30,'HIGHSCORES');
  outtextxy(236,63,'LEVEL '+txt1);
  setcolor(10);
  outtextxy(228,32,'HIGHSCORES');
  outtextxy(238,65,'LEVEL '+txt1);
  setcolor(8);
  outtextxy(227,31,'HIGHSCORES');
  outtextxy(237,64,'LEVEL '+txt1);
  settextstyle(0,0,1);
   seek(highscore,0);
   read(highscore,highdaten);
  drawdoublemenu(5,96,634,115,2,8,5,10);
  drawdoublemenu(5,116,634,135,2,8,5,10);
  drawdoublemenu(5,136,634,155,2,8,5,10);
  drawdoublemenu(5,156,634,175,2,16,18,17);
  drawdoublemenu(5,176,634,195,2,16,18,17);
  drawdoublemenu(5,196,634,215,2,16,18,17);
  drawdoublemenu(5,216,634,235,2,24,8,25);
  drawdoublemenu(5,236,634,255,2,24,8,25);
  drawdoublemenu(5,256,634,275,2,24,8,25);
  drawdoublemenu(5,276,634,295,2,24,8,25);
  setcolor(0);
  for lauf:=1 to 10 do begin
  str(lauf:2,txt3);
  str(highdaten.lang[nummer,lauf].lang:4,txt1);
  outtextxy(15,82+20*lauf,'  '+txt3+'. : Name : '+highdaten.lang[nummer,lauf].name);
  outtextxy(330,82+20*lauf,' Wurmlnge : '+txt1);
  end;
 auswahl:=3;
end;
if auswahl=1 then begin
 drawactivemenufield(215,5,424,29,13,2,'Lschen ? <ESC> fr JA');
 c1:=readkey;
 if c1=#27 then deletelanghigh;
  drawdoublemenu(195,32,444,61,3,8,5,10);
  drawdoublemenu(195,62,444,95,3,8,5,10);
  settextstyle(7,0,3);
  setcolor(5);
  str(nummer:4,txt1);
  outtextxy(226,30,'HIGHSCORES');
  outtextxy(236,63,'LEVEL '+txt1);
  setcolor(10);
  outtextxy(228,32,'HIGHSCORES');
  outtextxy(238,65,'LEVEL '+txt1);
  setcolor(8);
  outtextxy(227,31,'HIGHSCORES');
  outtextxy(237,64,'LEVEL '+txt1);
  settextstyle(0,0,1);
   seek(highscore,0);
   read(highscore,highdaten);
  drawdoublemenu(5,96,634,115,2,8,5,10);
  drawdoublemenu(5,116,634,135,2,8,5,10);
  drawdoublemenu(5,136,634,155,2,8,5,10);
  drawdoublemenu(5,156,634,175,2,16,18,17);
  drawdoublemenu(5,176,634,195,2,16,18,17);
  drawdoublemenu(5,196,634,215,2,16,18,17);
  drawdoublemenu(5,216,634,235,2,24,8,25);
  drawdoublemenu(5,236,634,255,2,24,8,25);
  drawdoublemenu(5,256,634,275,2,24,8,25);
  drawdoublemenu(5,276,634,295,2,24,8,25);
  setcolor(0);
  for lauf:=1 to 10 do begin
  str(lauf:2,txt3);
  str(highdaten.lang[nummer,lauf].lang:4,txt1);
  outtextxy(15,82+20*lauf,'  '+txt3+'. : Name : '+highdaten.lang[nummer,lauf].name);
  outtextxy(330,82+20*lauf,' Wurmlnge : '+txt1);
  end;
 auswahl:=3;
end;
if auswahl=2 then begin
 drawactivemenufield(425,5,634,29,13,2,'Neuer Level : =>      ');
 readnumber(575,13,19,3,nummer);
 if nummer<1 then nummer:=1;
 if nummer>100 then nummer:=100;
 (* LNGEN - HIGHSCORES HIER !!! *)
  drawdoublemenu(195,32,444,61,3,8,5,10);
  drawdoublemenu(195,62,444,95,3,8,5,10);
  settextstyle(7,0,3);
  setcolor(5);
  str(nummer:4,txt1);
  outtextxy(226,30,'HIGHSCORES');
  outtextxy(236,63,'LEVEL '+txt1);
  setcolor(10);
  outtextxy(228,32,'HIGHSCORES');
  outtextxy(238,65,'LEVEL '+txt1);
  setcolor(8);
  outtextxy(227,31,'HIGHSCORES');
  outtextxy(237,64,'LEVEL '+txt1);
  settextstyle(0,0,1);
   seek(highscore,0);
   read(highscore,highdaten);
  drawdoublemenu(5,96,634,115,2,8,5,10);
  drawdoublemenu(5,116,634,135,2,8,5,10);
  drawdoublemenu(5,136,634,155,2,8,5,10);
  drawdoublemenu(5,156,634,175,2,16,18,17);
  drawdoublemenu(5,176,634,195,2,16,18,17);
  drawdoublemenu(5,196,634,215,2,16,18,17);
  drawdoublemenu(5,216,634,235,2,24,8,25);
  drawdoublemenu(5,236,634,255,2,24,8,25);
  drawdoublemenu(5,256,634,275,2,24,8,25);
  drawdoublemenu(5,276,634,295,2,24,8,25);
  setcolor(0);
  for lauf:=1 to 10 do begin
  str(lauf:2,txt3);
  str(highdaten.lang[nummer,lauf].lang:4,txt1);
  outtextxy(15,82+20*lauf,'  '+txt3+'. : Name : '+highdaten.lang[nummer,lauf].name);
  outtextxy(330,82+20*lauf,' Wurmlnge : '+txt1);
  end;
 auswahl:=3;
end;
until auswahl=0;
end;

procedure insertworms;
begin
assign(bildfile,'wurm2563.pic');
reset(bildfile);
getmem(bildspeicher,imagesize(350,240,510,360));
blockread(bildfile,bildspeicher^,211);
putimage(15,240,bildspeicher^,0);
freemem(bildspeicher,imagesize(350,240,510,360));
close(bildfile);
assign(bildfile,'wurm2562.pic');
reset(bildfile);
getmem(bildspeicher,imagesize(350,240,510,360));
blockread(bildfile,bildspeicher^,211);
putimage(460,240,bildspeicher^,0);
freemem(bildspeicher,imagesize(350,240,510,360));
close(bildfile);       
end;

procedure insertwurmquest;
begin
for lauf:=0 to 15 do begin
 setrgbpalette(lauf+50,lauf*4,lauf*4,lauf*4);
end;
assign(bildfile,'wurm2561.pic');
getmem(bildspeicher,imagesize(10,373,329,469));
reset(bildfile);
blockread(bildfile,bildspeicher^,511);
putimage(10,373,bildspeicher^,0);
freemem(bildspeicher,imagesize(10,373,629,469));
close(bildfile);
end;

procedure drawextras;
begin
insertworms;
drawdoublemenu(320,55,634,104,3,16,18,17);
setcolor(10);
outtextxy(329,63,'Copyright in 1994 by the ultimate');
outtextxy(329,73,'WURMQUEST-Programmierer:');
settextstyle(tscr,0,1);
outtextxy(329,80,'STEFAN STRMSDRFER');
settextstyle(0,0,1);
setcolor(5);
settextstyle(tscr,0,1);
outtextxy(327,78,'STEFAN STRMSDRFER');
settextstyle(0,0,1);
setcolor(8);
outtextxy(328,62,'Copyright in 1994 by the ultimate');
outtextxy(328,72,'WURMQUEST-Programmierer:');
settextstyle(tscr,0,1);
outtextxy(328,79,'STEFAN STRMSDRFER');
settextstyle(0,0,1);
drawdoublemenu(320,155,634,229,3,8,5,10);
setcolor(10);
outtextxy(328,163,'SPECIAL GREETINGS TO:');
outtextxy(328,173,'JRGEN BSS');
outtextxy(328,183,'CHRISTOPHER KURZ');
outtextxy(328,193,'ANDREAS BERNET');
setcolor(5);
outtextxy(330,165,'SPECIAL GREETINGS TO:');
outtextxy(330,175,'JRGEN BSS');
outtextxy(330,185,'CHRISTOPHER KURZ');
outtextxy(330,195,'ANDREAS BERNET');
setcolor(0);
outtextxy(329,164,'SPECIAL GREETINGS TO:');
outtextxy(329,174,'JRGEN BSS');
outtextxy(329,184,'CHRISTOPHER KURZ');
outtextxy(329,194,'ANDREAS BERNET');
end;


procedure startmenu;
var wahl:integer;
    txt:string;
    c:char;
begin
assign(highscore,'wurm256.hi');
{$i-}
reset(highscore);
{$i+}
if ioresult<>0 then neueshighscore;
wahl:=0;
spieleranzahl:=1;
cpuspeed:=0;
getcpuspeed;
waittime:=750-cpuspeed;
level:=1;
schwierigkeit:=1;
name[1]:='Spieler 1';
name[2]:='Spieler 2';
setrgbpalette(32,30,60,10);
setrgbpalette(16,35,35,35);
setrgbpalette(17,15,15,15);
setrgbpalette(18,55,55,55);
setrgbpalette(19,0,40,20);
setrgbpalette(20,0,15,5);
setrgbpalette(21,0,55,35);
drawdoublemenu(0,0,639,479,3,15,14,0);
drawdoublemenu(5,368,634,474,3,8,5,10);
insertwurmquest;
drawinactivemenufield(5,5,319,29,13,2,'Neues Wurmspiel');
drawinactivemenufield(5,30,319,54,38,2,'Passwort eingeben');
str(spieleranzahl,txt);
drawinactivemenufield(5,55,319,79,63,2,txt+' Spieler');
case schwierigkeit of
 0:txt:='leicht';
 1:txt:='mittel';
 2:txt:='schwer';
end;
drawinactivemenufield(5,80,319,104,88,2,'Schwierigkeitsgrad : '+txt);
drawinactivemenufield(5,105,319,129,113,2,'Spieler 1: '+name[1]);
drawinactivemenufield(5,130,319,154,138,2,'Spieler 2: '+name[2]);
drawinactivemenufield(5,155,319,179,163,2,'Punktehighscore sehen');
drawinactivemenufield(5,180,319,204,188,2,'Lngenhighscore sehen');
drawinactivemenufield(5,205,319,229,213,2,'ENDE');
drawextras;

str(level,txt);
drawinactivemenufield(320,5,634,29,13,2,'Level '+txt);
drawinactivemenufield(320,30,634,54,38,2,'Passwort : '+levelnamen[level]);
drawinactivemenufield(320,105,634,129,38,2,'');
setfillstyle(1,0);
bar(323,108,630,125);
putimage(328,114,wurmkopf[1].w^,0);
putimage(333,114,wurmleib[1].h^,0);
putimage(338,114,wurmleib[1].lo^,0);
putimage(338,109,wurmleib[1].ru^,0);
putimage(343,109,wurmleib[1].h^,0);
putimage(348,109,wurmleib[1].lu^,0);
putimage(348,114,wurmleib[1].v^,0);
putimage(348,119,wurmleib[1].ro^,0);
putimage(353,119,wurmleib[1].lo^,0);
putimage(353,114,wurmleib[1].ru^,0);
putimage(358,114,wurmende[1].w^,0);
drawinactivemenufield(320,130,634,154,38,2,'');
setfillstyle(1,0);
bar(323,133,630,150);
putimage(328,139,wurmkopf[2].w^,0);
putimage(333,139,wurmleib[2].lu^,0);
putimage(333,144,wurmleib[2].ro^,0);
putimage(338,144,wurmleib[2].lo^,0);
putimage(338,139,wurmleib[2].ru^,0);
putimage(343,139,wurmleib[2].h^,0);
putimage(348,139,wurmleib[2].h^,0);
putimage(353,139,wurmleib[2].h^,0);
putimage(358,139,wurmleib[2].h^,0);
putimage(363,139,wurmleib[2].lu^,0);
putimage(363,144,wurmende[2].n^,0);  
repeat
case wahl of
0:drawactivemenufield(5,5,319,29,13,2,'Neues Wurmspiel');
1:drawactivemenufield(5,30,319,54,38,2,'Passwort eingeben');
2:begin
    str(spieleranzahl,txt);
    drawactivemenufield(5,55,319,79,63,2,txt+' Spieler');
  end;
3:begin
    case schwierigkeit of
      0:txt:='leicht';
      1:txt:='mittel';
      2:txt:='schwer';
    end;
    drawactivemenufield(5,80,319,104,88,2,'Schwierigkeitsgrad : '+txt);
  end;
4:drawactivemenufield(5,105,319,129,113,2,'Spieler 1: '+name[1]);
5:drawactivemenufield(5,130,319,154,138,2,'Spieler 2: '+name[2]);
6:drawactivemenufield(5,155,319,179,163,2,'Punktehighscore sehen');
7:drawactivemenufield(5,180,319,204,188,2,'Lngenhighscore sehen');
8:drawactivemenufield(5,205,319,229,213,2,'ENDE');
end;
c:=readkey;
case wahl of
0:drawinactivemenufield(5,5,319,29,13,2,'Neues Wurmspiel');
1:drawinactivemenufield(5,30,319,54,38,2,'Passwort eingeben');
2:begin
    str(spieleranzahl,txt);
    drawinactivemenufield(5,55,319,79,63,2,txt+' Spieler');
  end;
3:begin
    case schwierigkeit of      
      0:begin txt:='leicht';waittime:=950-cpuspeed;end;
      1:begin txt:='mittel';waittime:=650-cpuspeed;end;
      2:begin txt:='schwer';waittime:=450-cpuspeed;end;
    end;
    drawinactivemenufield(5,80,319,104,88,2,'Schwierigkeitsgrad : '+txt);
  end;
4:drawinactivemenufield(5,105,319,129,113,2,'Spieler 1: '+name[1]);
5:drawinactivemenufield(5,130,319,154,138,2,'Spieler 2: '+name[2]);
6:drawinactivemenufield(5,155,319,179,163,2,'Punktehighscore sehen');
7:drawinactivemenufield(5,180,319,204,188,2,'Lngenhighscore sehen');
8:drawinactivemenufield(5,205,319,229,213,2,'ENDE');
end;
case c of
 #72,#77:wahl:=wahl-1;
 #80,#75:wahl:=wahl+1;
 #13: case wahl of
        0: begin
            altlevel:=level;
             neuesspiel;
               drawdoublemenu(0,0,639,479,3,15,14,0);
               drawinactivemenufield(5,5,319,29,13,2,'Neues Wurmspiel');
               drawinactivemenufield(5,30,319,54,38,2,'Passwort eingeben');
               str(spieleranzahl,txt);
               drawinactivemenufield(5,55,319,79,63,2,txt+' Spieler');
               case schwierigkeit of
                0:begin txt:='leicht';waittime:=950-cpuspeed;end;
                 1:begin txt:='mittel';waittime:=650-cpuspeed;end;
                  2:begin txt:='schwer';waittime:=450-cpuspeed;end;
                  end;
                  drawinactivemenufield(5,80,319,104,88,2,'Schwierigkeitsgrad : '+txt);
                  drawinactivemenufield(5,105,319,129,113,2,'Spieler 1: '+name[1]);
                  drawinactivemenufield(5,130,319,154,138,2,'Spieler 2: '+name[2]);
                  drawinactivemenufield(5,155,319,179,163,2,'Punktehighscore sehen');
                  drawinactivemenufield(5,180,319,204,188,2,'Lngenhighscore sehen');
                  drawinactivemenufield(5,205,319,229,213,2,'ENDE');
                  drawextras;
                  str(level,txt);
                  drawdoublemenu(5,368,634,474,3,8,5,10);
                  insertwurmquest;
                  drawinactivemenufield(320,5,634,29,13,2,'Level '+txt);
                  drawinactivemenufield(320,30,634,54,38,2,'Passwort : '+levelnamen[level]);
                  drawinactivemenufield(320,105,634,129,38,2,'');
                  setfillstyle(1,0);
                  bar(323,108,630,125);
                  putimage(328,114,wurmkopf[1].w^,0);
                  putimage(333,114,wurmleib[1].h^,0);
                  putimage(338,114,wurmleib[1].lo^,0);
                  putimage(338,109,wurmleib[1].ru^,0);
                  putimage(343,109,wurmleib[1].h^,0);
                  putimage(348,109,wurmleib[1].lu^,0);
                  putimage(348,114,wurmleib[1].v^,0);
                  putimage(348,119,wurmleib[1].ro^,0);
                  putimage(353,119,wurmleib[1].lo^,0);
                  putimage(353,114,wurmleib[1].ru^,0);
                  putimage(358,114,wurmende[1].w^,0);
                  drawinactivemenufield(320,130,634,154,38,2,'');
                  setfillstyle(1,0);
                  bar(323,133,630,150);
                  putimage(328,139,wurmkopf[2].w^,0);
                  putimage(333,139,wurmleib[2].lu^,0);
                  putimage(333,144,wurmleib[2].ro^,0);
                  putimage(338,144,wurmleib[2].lo^,0);
                  putimage(338,139,wurmleib[2].ru^,0);
                  putimage(343,139,wurmleib[2].h^,0);
                  putimage(348,139,wurmleib[2].h^,0);
                  putimage(353,139,wurmleib[2].h^,0);
                  putimage(358,139,wurmleib[2].h^,0);
                  putimage(363,139,wurmleib[2].lu^,0);
                  putimage(363,144,wurmende[2].n^,0);
           end;
        1: begin passwort;drawinactivemenufield(320,30,634,54,38,2,'Passwort : '+levelnamen[level]);end;
        2: begin
             drawactivemenufield(5,55,319,79,63,2,'Spieleranzahl : =>');
             readnumber(250,63,19,1,spieleranzahl);
             if (spieleranzahl<1) or (spieleranzahl>2) then spieleranzahl:=1;
           end;
        3: begin
           case schwierigkeit of
             0:txt:='leicht';
             1:txt:='mittel';
             2:txt:='schwer';
           end;
           drawactivemenufield(5,80,319,104,88,2,'Schwierigkeitsgrad : '+txt);
            repeat
             c:=readkey;
             case c of
               #72:schwierigkeit:=schwierigkeit+1;
               #80:schwierigkeit:=schwierigkeit-1;
             end;
             if schwierigkeit<0 then schwierigkeit:=0;
             if schwierigkeit>2 then schwierigkeit:=2;
             case schwierigkeit of
               0:txt:='leicht';
               1:txt:='mittel';
               2:txt:='schwer';
             end;
             drawactivemenufield(5,80,319,104,88,2,'Schwierigkeitsgrad : '+txt);
            until c=#13;
           end;
        4:begin
            drawactivemenufield(5,105,319,129,113,2,'Name : =>                 ');
            readstring(150,113,19,15,name[1]);
          end;
        5:begin
            drawactivemenufield(5,130,319,154,138,2,'Name : =>                 ');
            readstring(150,138,19,15,name[2]);
          end;
        6:begin
            showpunktehigh;
            drawdoublemenu(0,0,639,479,3,15,14,0);
            drawinactivemenufield(5,5,319,29,13,2,'Neues Wurmspiel');
            drawinactivemenufield(5,30,319,54,38,2,'Passwort eingeben');
            str(spieleranzahl,txt);
            drawinactivemenufield(5,55,319,79,63,2,txt+' Spieler');
            case schwierigkeit of
             0:txt:='leicht';
              1:txt:='mittel';
               2:txt:='schwer';
               end;
               drawinactivemenufield(5,80,319,104,88,2,'Schwierigkeitsgrad : '+txt);
               drawinactivemenufield(5,105,319,129,113,2,'Spieler 1: '+name[1]);
               drawinactivemenufield(5,130,319,154,138,2,'Spieler 2: '+name[2]);
               drawinactivemenufield(5,155,319,179,163,2,'Punktehighscore sehen');
               drawinactivemenufield(5,180,319,204,188,2,'Lngenhighscore sehen');
               drawinactivemenufield(5,205,319,229,213,2,'ENDE');
               drawextras;
               str(level,txt);
               drawdoublemenu(5,368,634,474,3,8,5,10);
               insertwurmquest;
               drawinactivemenufield(320,5,634,29,13,2,'Level '+txt);
               drawinactivemenufield(320,30,634,54,38,2,'Passwort : '+levelnamen[level]);
               drawinactivemenufield(320,105,634,129,38,2,'');
               setfillstyle(1,0);
               bar(323,108,630,125);
               putimage(328,114,wurmkopf[1].w^,0);
               putimage(333,114,wurmleib[1].h^,0);
               putimage(338,114,wurmleib[1].lo^,0);
               putimage(338,109,wurmleib[1].ru^,0);
               putimage(343,109,wurmleib[1].h^,0);
               putimage(348,109,wurmleib[1].lu^,0);
               putimage(348,114,wurmleib[1].v^,0);
               putimage(348,119,wurmleib[1].ro^,0);
               putimage(353,119,wurmleib[1].lo^,0);
               putimage(353,114,wurmleib[1].ru^,0);
               putimage(358,114,wurmende[1].w^,0);
               drawinactivemenufield(320,130,634,154,38,2,'');
               setfillstyle(1,0);
               bar(323,133,630,150);
               putimage(328,139,wurmkopf[2].w^,0);
               putimage(333,139,wurmleib[2].lu^,0);
               putimage(333,144,wurmleib[2].ro^,0);
               putimage(338,144,wurmleib[2].lo^,0);
               putimage(338,139,wurmleib[2].ru^,0);
               putimage(343,139,wurmleib[2].h^,0);
               putimage(348,139,wurmleib[2].h^,0);
               putimage(353,139,wurmleib[2].h^,0);
               putimage(358,139,wurmleib[2].h^,0);
               putimage(363,139,wurmleib[2].lu^,0);
               putimage(363,144,wurmende[2].n^,0);
          end;
        7:begin
            showlanghigh;
            drawdoublemenu(0,0,639,479,3,15,14,0);
            drawinactivemenufield(5,5,319,29,13,2,'Neues Wurmspiel');
            drawinactivemenufield(5,30,319,54,38,2,'Passwort eingeben');
            str(spieleranzahl,txt);
            drawinactivemenufield(5,55,319,79,63,2,txt+' Spieler');
            case schwierigkeit of
             0:txt:='leicht';
              1:txt:='mittel';
               2:txt:='schwer';
               end;
               drawinactivemenufield(5,80,319,104,88,2,'Schwierigkeitsgrad : '+txt);
               drawinactivemenufield(5,105,319,129,113,2,'Spieler 1: '+name[1]);
               drawinactivemenufield(5,130,319,154,138,2,'Spieler 2: '+name[2]);
               drawinactivemenufield(5,155,319,179,163,2,'Punktehighscore sehen');
               drawinactivemenufield(5,180,319,204,188,2,'Lngenhighscore sehen');
               drawinactivemenufield(5,205,319,229,213,2,'ENDE');
               drawextras;
               str(level,txt);
               drawdoublemenu(5,368,634,474,3,8,5,10);
               insertwurmquest;
               drawinactivemenufield(320,5,634,29,13,2,'Level '+txt);
               drawinactivemenufield(320,30,634,54,38,2,'Passwort : '+levelnamen[level]);
               drawinactivemenufield(320,105,634,129,38,2,'');
               setfillstyle(1,0);
               bar(323,108,630,125);
               putimage(328,114,wurmkopf[1].w^,0);
               putimage(333,114,wurmleib[1].h^,0);
               putimage(338,114,wurmleib[1].lo^,0);
               putimage(338,109,wurmleib[1].ru^,0);
               putimage(343,109,wurmleib[1].h^,0);
               putimage(348,109,wurmleib[1].lu^,0);
               putimage(348,114,wurmleib[1].v^,0);
               putimage(348,119,wurmleib[1].ro^,0);
               putimage(353,119,wurmleib[1].lo^,0);
               putimage(353,114,wurmleib[1].ru^,0);
               putimage(358,114,wurmende[1].w^,0);
               drawinactivemenufield(320,130,634,154,38,2,'');
               setfillstyle(1,0);
               bar(323,133,630,150);
               putimage(328,139,wurmkopf[2].w^,0);
               putimage(333,139,wurmleib[2].lu^,0);
               putimage(333,144,wurmleib[2].ro^,0);
               putimage(338,144,wurmleib[2].lo^,0);
               putimage(338,139,wurmleib[2].ru^,0);
               putimage(343,139,wurmleib[2].h^,0);
               putimage(348,139,wurmleib[2].h^,0);
               putimage(353,139,wurmleib[2].h^,0);
               putimage(358,139,wurmleib[2].h^,0);
               putimage(363,139,wurmleib[2].lu^,0);
               putimage(363,144,wurmende[2].n^,0);
          end;
        8:begin
            drawinactivemenufield(5,205,319,229,213,2,'Wirklich beenden ? (<ESC> fr Ende)');
            c:=readkey;
            if c=#27 then wahl:=99;
          end; 
      end;
end;
if wahl<0 then wahl:=8;
if wahl=9 then wahl:=0; 
until wahl=99;
close(highscore);
end;

procedure readstring(x,y:word;backgcol:byte;len:byte;var readvar:string);
var c:char;
read2:string;
i:integeR;
txt:string;
begin
readvar:='';
repeat
c:=readkey;
case c of
  #8: begin
        bar(x,y,x+length(readvar)*9,y+8);
        readvar:='';    
      end; 
else if c<>#13 then readvar:=readvar+c;
end;
setfillstyle(1,backgcol);
bar(x,y,x+length(readvar)*9,y+8);
outtextxy(x,y,readvar);
until (c=#13) or (length(readvar)=len);
end;

procedure readnumber(x,y:word;backgcol:byte;len:byte;var num:longint);
var c:char;
txt:string;
begin
num:=0;
repeat
c:=readkey;
case c of
  '1':num:=num*10+1;
  '2':num:=num*10+2;
  '3':num:=num*10+3;
  '4':num:=num*10+4;
  '5':num:=num*10+5;
  '6':num:=num*10+6;
  '7':num:=num*10+7;
  '8':num:=num*10+8;
  '9':num:=num*10+9;
  '0':num:=num*10;
  #8: begin
      bar(x,y,x+length(txt)*9,y+8);
      num:=num div 10;
      end;
end;
str(num,txt);
setfillstyle(1,backgcol);
bar(x,y,x+length(txt)*9,y+8);
outtextxy(x,y,txt);
until (c=#13) or (length(txt)=len);
end;

procedure drawdoublemenu(x1,y1,x2,y2,d:word;normal,hell,dunkel:byte);
begin
setfillstyle(1,normal);
bar(x1,y1,x2,y2);
setcolor(hell);
line(x1,y1,x2,y1);
line(x1,y1,x1,y2);
line(x1+d,y2-d,x2-d,y2-d);
line(x2-d,y1+d,x2-d,y2-d);
setcolor(dunkel);
line(x1,y2,x2,y2);
line(x2,y1,x2,y2);
line(x1+d,y1+d,x2-d,y1+d);
line(x1+d,y1+d,x1+d,y2-d);
end;

procedure steinedef;
begin
for lauf:=1 to 10 do begin
  getmem(steine[lauf],imagesize(0,0,4,4));
end;
 (* Steinart 1 Blau *)
setrgbpalette(1,0,0,60);
setrgbpalette(2,0,0,20);
setfillstyle(1,1);
bar(1,1,3,3);
setcolor(2);
rectangle(0,0,4,4);
getimage(0,0,4,4,steine[1]^);
 (* Steinart 2 Cyan *)
setrgbpalette(3,0,50,50);
setrgbpalette(4,0,25,25);
setrgbpalette(5,63,63,63);
setfillstyle(1,3);
setcolor(4);
bar(1,1,3,3);
rectangle(0,0,4,4);
getimage(0,0,4,4,steine[2]^);
 (* Steinart 3 Grn *)
setrgbpalette(6,3,30,0);
setrgbpalette(7,10,60,0);
setfillstyle(1,7);
setcolor(6);
bar(1,1,3,3);
rectangle(0,0,4,4);
getimage(0,0,4,4,steine[3]^);
 (* Steinart 4 gelb *)
setrgbpalette(8,63,50,0);
setrgbpalette(9,31,25,0);
setfillstyle(1,8);
setcolor(9);
bar(1,1,3,3);
rectangle(0,0,4,4);
putpixel(1,1,5);
getimage(0,0,4,4,steine[4]^);
 (* Steinart 5 Rot *)
setrgbpalette(10,60,0,0);
setrgbpalette(11,30,0,0);
setfillstyle(1,10);
setcolor(11);
bar(1,1,3,3);
rectangle(0,0,4,4);
getimage(0,0,4,4,steine[5]^);
 (* Steinart 6 Magenta *)
setrgbpalette(22,50,0,50);
setrgbpalette(23,25,0,25);
setfillstyle(1,22);
setcolor(23);
bar(1,1,3,3);
rectangle(0,0,4,4);
getimage(0,0,4,4,steine[6]^);
 (* Steinart 7 Braun *)
setrgbpalette(24,45,20,10);
setrgbpalette(25,22,10,5);
setfillstyle(1,24);
setcolor(25);
bar(1,1,3,3);
rectangle(0,0,4,4);
getimage(0,0,4,4,steine[7]^);
 (* Steinart 8 Grau *)
setrgbpalette(26,40,40,40);
setrgbpalette(27,20,20,20);
setfillstyle(1,26);
setcolor(27);
bar(1,1,3,3);
rectangle(0,0,4,4);
getimage(0,0,4,4,steine[8]^);
 (* Steinart 9 Kornblumenblau *)
setrgbpalette(28,22,30,60);
setrgbpalette(29,11,16,32);
setfillstyle(1,28);
setcolor(29);
bar(1,1,3,3);
rectangle(0,0,4,4);
getimage(0,0,4,4,steine[9]^);
 (* Steinart 10 violett *)
setrgbpalette(30,30,0,60);
setrgbpalette(31,15,0,30);
setfillstyle(1,30);
setcolor(31);
bar(1,1,3,3);
rectangle(0,0,4,4);
getimage(0,0,4,4,steine[10]^);

end;

procedure wurmdef;
begin
for lauf:=1 to 2 do begin
  getmem(wurmkopf[lauf].n,imagesize(0,0,4,4));
  getmem(wurmkopf[lauf].o,imagesize(0,0,4,4));
  getmem(wurmkopf[lauf].s,imagesize(0,0,4,4));
  getmem(wurmkopf[lauf].w,imagesize(0,0,4,4));
  getmem(wurmleib[lauf].h,imagesize(0,0,4,4));
  getmem(wurmleib[lauf].v,imagesize(0,0,4,4));
  getmem(wurmleib[lauf].lu,imagesize(0,0,4,4));
  getmem(wurmleib[lauf].lo,imagesize(0,0,4,4));
  getmem(wurmleib[lauf].ro,imagesize(0,0,4,4));
  getmem(wurmleib[lauf].ru,imagesize(0,0,4,4));
  getmem(wurmende[lauf].n,imagesize(0,0,4,4));
  getmem(wurmende[lauf].o,imagesize(0,0,4,4));
  getmem(wurmende[lauf].s,imagesize(0,0,4,4));
  getmem(wurmende[lauf].w,imagesize(0,0,4,4));
end;
setfillstyle(1,0);
bar(0,0,4,4);
setrgbpalette(12,0,30,0);
setrgbpalette(13,20,40,0);
setrgbpalette(14,0,30,60);
setrgbpalette(15,0,10,60);
 (* Definition der Wurmkpfe (2 * 4 Richtungen) *)
setfillstyle(1,13);
setcolor(12);
fillellipse(2,2,2,2);
putpixel(1,1,0);putpixel(3,1,0);
getimage(0,0,4,4,wurmkopf[1].n^);
fillellipse(2,2,2,2);            
putpixel(3,3,0);putpixel(3,1,0);
getimage(0,0,4,4,wurmkopf[1].o^);
fillellipse(2,2,2,2);              
putpixel(1,3,0);putpixel(3,3,0);
getimage(0,0,4,4,wurmkopf[1].s^); 
fillellipse(2,2,2,2);     
putpixel(1,1,0);putpixel(1,3,0);
getimage(0,0,4,4,wurmkopf[1].w^);  
setfillstyle(1,14);
setcolor(15);
fillellipse(2,2,2,2);
putpixel(1,1,0);putpixel(3,1,0);
getimage(0,0,4,4,wurmkopf[2].n^);
fillellipse(2,2,2,2);
putpixel(3,3,0);putpixel(3,1,0);
getimage(0,0,4,4,wurmkopf[2].o^);
fillellipse(2,2,2,2);
putpixel(1,3,0);putpixel(3,3,0);
getimage(0,0,4,4,wurmkopf[2].s^);
fillellipse(2,2,2,2);
putpixel(1,1,0);putpixel(1,3,0);
getimage(0,0,4,4,wurmkopf[2].w^);
 (* Definition der Wurmkrper ( 2 * 2 Richtungen
    und 2 * 4 Kurven *)
 (* Wurm 1 *)
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(12);
rectangle(0,1,4,3);
setcolor(13);
line(0,2,4,2);
getimage(0,0,4,4,wurmleib[1].h^);
bar(0,0,4,4);
setcolor(12);
rectangle(1,0,3,4);
setcolor(13);
line(2,0,2,4);
getimage(0,0,4,4,wurmleib[1].v^);
   (* Wurm 2 *)
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(15);
rectangle(0,1,4,3);
setcolor(14);
line(0,2,4,2);
getimage(0,0,4,4,wurmleib[2].h^);
bar(0,0,4,4);
setcolor(15);
rectangle(1,0,3,4);
setcolor(14);
line(2,0,2,4);
getimage(0,0,4,4,wurmleib[2].v^);
  (* Wurm 1 Kurven *)
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(12);
rectangle(0,1,2,3);
rectangle(1,4,3,2);
setcolor(13);
line(0,2,2,2);
line(2,4,2,2);
getimage(0,0,4,4,wurmleib[1].lu^);
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(12);
rectangle(0,1,2,3);
rectangle(1,0,3,2);
setcolor(13);
line(0,2,2,2);
line(2,0,2,2);
getimage(0,0,4,4,wurmleib[1].lo^);
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(12);
rectangle(1,0,3,2);
rectangle(4,1,2,3);
setcolor(13);
line(2,0,2,2);
line(4,2,2,2);
getimage(0,0,4,4,wurmleib[1].ro^);
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(12);
rectangle(1,4,3,2);
rectangle(4,1,2,3);
setcolor(13);
line(2,4,2,2);
line(4,2,2,2);
getimage(0,0,4,4,wurmleib[1].ru^);
  (* Wurm 2 Kurven *)
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(15);
rectangle(0,1,2,3);
rectangle(1,4,3,2);
setcolor(14);
line(0,2,2,2);
line(2,4,2,2);
getimage(0,0,4,4,wurmleib[2].lu^);
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(15);
rectangle(0,1,2,3);
rectangle(1,0,3,2);
setcolor(14);
line(0,2,2,2);
line(2,0,2,2);
getimage(0,0,4,4,wurmleib[2].lo^);
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(15);
rectangle(1,0,3,2);
rectangle(4,1,2,3);
setcolor(14);
line(2,0,2,2);
line(4,2,2,2);
getimage(0,0,4,4,wurmleib[2].ro^);
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(15);
rectangle(1,4,3,2);
rectangle(4,1,2,3);
setcolor(14);
line(2,4,2,2);
line(4,2,2,2);
getimage(0,0,4,4,wurmleib[2].ru^);
 (* Wurmenden 1  2 * 4 *)
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(12);
rectangle(1,0,3,2);
line(2,3,2,4);
setcolor(13);
line(2,0,2,2);
getimage(0,0,4,4,wurmende[1].n^);
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(12);
rectangle(4,1,2,3);
line(0,2,1,2);
setcolor(13);
line(4,2,2,2);
getimage(0,0,4,4,wurmende[1].o^);
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(12);
rectangle(1,4,3,2);
line(2,1,2,0);
setcolor(13);
line(2,2,2,4);
getimage(0,0,4,4,wurmende[1].s^);
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(12);
rectangle(0,1,2,3);
line(3,2,4,2);
setcolor(13);
line(0,2,2,2);
getimage(0,0,4,4,wurmende[1].w^); 
 (* Wurm 2 *)
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(15);
rectangle(1,0,3,2);
line(2,3,2,4);
setcolor(14);
line(2,0,2,2);
getimage(0,0,4,4,wurmende[2].n^);
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(15);
rectangle(4,1,2,3);
line(0,2,1,2);
setcolor(14);
line(4,2,2,2);
getimage(0,0,4,4,wurmende[2].o^);
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(15);
rectangle(1,4,3,2);
line(2,1,2,0);
setcolor(14);
line(2,2,2,4);
getimage(0,0,4,4,wurmende[2].s^);
setfillstyle(1,0);
bar(0,0,4,4);
setcolor(15);
rectangle(0,1,2,3);
line(3,2,4,2);
setcolor(14);
line(0,2,2,2);
getimage(0,0,4,4,wurmende[2].w^); 
end;

begin

end.
